/* defining the position_t struct */
typedef struct {
    float x;
    float y;
    int tlinks;
    int rlinks;
    int senders;
    int receivers;
} position_t;

/* defining the edges_t struct */
typedef struct {
    int from;
    int to;
    int delay;
    int bandwidth;
    int state;
} edge_t;

/* defining the buses struct */
typedef struct {
    int node;
    int from;
    int to;
    float from_x;
    float from_y;
    float to_x;
    float to_y;
} ethernets_t;

/* defining the taps struct */
typedef struct {
    int object;
    int w;
    int bus;
    int from;
    int to;
    float from_x;
    float from_y;
    float to_x;
    float to_y;
} taps_t;

/* defining the senders receivers positioning */
typedef struct {
    float x;
    float y;
} sc_position_t;

/* Defining Initialization header 1 of output */
#define INIT_HEADER1 \
"main (int argc, char* argv [])
        {
        EmaT_Model_Id                   model_id;
        int                                     i;

        /* initialize EMA package */
        Ema_Init (EMAC_MODE_ERR_PRINT, argc, argv);

        /* create an empty model */
        model_id = Ema_Model_Create (MOD_NETWORK);



        /* create all objects */
        obj [0] = Ema_Object_Create (model_id, OBJ_NT_SUBNET);
        obj [1] = Ema_Object_Create (model_id, OBJ_NT_SUBNET_VIEW);
"

/* defining Initialization Header 2 for output */
#define INIT_HEADER2 \
"



        /* set the model level attributes */
        /* create and init prg list 'prg_lptr [0]' */
        prg_lptr [0] = prg_list_create ();
        /* create and init prg list 'prg_lptr [1]' */
        prg_lptr [1] = prg_list_create ();
        prg_list_strings_append (prg_lptr [1],
                \"custom_model_list\",
                \"ospf_net\",
                PRGC_NIL);

        Ema_Model_Attr_Set (model_id,
                \"ext fileset\",          COMP_CONTENTS, prg_lptr [0],
                \"keywords list\",        COMP_CONTENTS, prg_lptr [1],
                \"view subnet\",          COMP_CONTENTS, obj [0],
                EMAC_EOL);



        /* assign attrs for object 'obj [0]' */
        Ema_Object_Attr_Set (model_id, obj [0],
                \"name\",                 COMP_CONTENTS, \"top\",
                \"x position\",           COMP_CONTENTS, (double) 0,
                \"y position\",           COMP_CONTENTS, (double) 0,
                \"x center\",             COMP_CONTENTS, (double) 0,
                \"y center\",             COMP_CONTENTS, (double) 0,
                \"y span\",               COMP_CONTENTS, (double) 180,
                \"x span\",               COMP_CONTENTS, (double) 360,
                \"icon name\",            COMP_CONTENTS_SYMBOL, \"subnet\",
                \"icon name\",            COMP_INTENDED, EMAC_DISABLED,
                \"subnet\",               COMP_CONTENTS, EMAC_NULL_OBJ_ID,
                \"view stack\",           COMP_ARRAY_CONTENTS (0), obj [1],
                \"grid unit\",            COMP_CONTENTS, 5,
                \"grid division\",        COMP_CONTENTS, (double) 15,
                \"grid resolution\",      COMP_CONTENTS, (double) 2.5,
                \"grid min x\",           COMP_CONTENTS, (double) -180,
                \"grid min y\",           COMP_CONTENTS, (double) 90,
                EMAC_EOL);

        Ema_Object_Attr_Set (model_id, obj [0],
                \"grid style\",           COMP_CONTENTS, 2,
                \"grid color\",           COMP_CONTENTS, 21,
                EMAC_EOL);


"


#define FOOTER \
"

        /* assign attrs for object 'obj [1]' */
        Ema_Object_Attr_Set (model_id, obj [1],
                \"min x\",                COMP_CONTENTS, (double) -180,
                \"min y\",                COMP_CONTENTS, (double) 90,
                \"sbar x\",               COMP_CONTENTS, (double) 0,
                \"sbar y\",               COMP_CONTENTS, (double) 0,
                \"grid step\",            COMP_CONTENTS, (double) 15,
                \"resolution\",           COMP_CONTENTS, (double) 2.5,
                \"grid style\",           COMP_CONTENTS, 2,
                \"grid color\",           COMP_CONTENTS, 21,
                EMAC_EOL);








"
